//Chris Carlson Final Project 220.
//Sound sample looper.

public class Noises{
	
	
	"/Users/carlson/Desktop/220b_final/sounds/" => string soundDir;
	
	//total number of samples;
	8 => int numSamples;
	
	//get number of output channels in use from filter spatializer
	FilterSpat.getNumChans() =>int numChans;
	
	//create sound buffers and gain objects
	SndBuf bufs[numSamples];
	Gain gains[numSamples];
	
	//load samples
	soundDir + "voice1.wav" => bufs[0].read;
	soundDir + "voice2.wav" => bufs[1].read;
	soundDir + "voice3.wav" => bufs[2].read;
	soundDir + "voice4.wav" => bufs[3].read;
	soundDir + "voice1.wav" => bufs[4].read;
	soundDir + "voice2.wav" => bufs[5].read;
	soundDir + "voice3.wav" => bufs[6].read;
	soundDir + "voice4.wav" => bufs[7].read;
	
	
	//each sample is sent to every speaker through an envelope (panning similar to that performed in FiltSpat.ck
	//without the feedback delays);
	numSamples*numChans => int totalChans;
	Envelope envs[totalChans];
	
	
	//soft takeover threshold
	0.2 => float sThresh;
	
	//gain parameters
	1.0 => float globalGain;
	1.0 => float maxGain;
	
	//keep track of envelope on/off states
	int envStates[numSamples];
	
	//connect outputs to each speaker
	0 => int counter;
	Gain connectBuf;
	//Gain wet[totalChans];
	for(int i; i < totalChans; i++){
		envs[i] => dac.chan(i % numChans); 
		if (i % numChans == 0){
			bufs[counter] => gains[counter] @=> connectBuf;
			0 => gains[counter].gain;
			bufs[counter].pos(0);
			bufs[counter].loop(1);
			Std.rand2f(0.4,0.8) => bufs[counter].rate;
			counter++;
		}
		connectBuf => envs[i];
		envs[i].keyOff();
		//initial attack/release duration is 0.5 second
		envs[i].duration(0.5::second);
	}
	
	
	//pick initial on locations
	int currentEnvs[numSamples];
	0 => int ctr;
	numChans/numSamples => int inc;
	for (int i; i < numSamples; i++){
		i*numChans + ctr*inc => currentEnvs[i];
		//envs[currentEnvs[i]].keyOn();
		ctr++;
		
	}	
		
	<<<"NOISE INIT DONE">>>;
	
	//modify gain for a single voice/sample
	fun void setGain(int vIdx, float val){
		checkRange(val,0.0,maxGain) => val;
		softCheck(gains[vIdx].gain(),val,sThresh) => int ok;
		if (ok == 1){
			if ((val > 0.0) && (envStates[vIdx] == 0)) {
				envs[currentEnvs[vIdx]].keyOn();
			}else if ((val == 0) && (envStates[vIdx] == 1)){
				envs[currentEnvs[vIdx]].keyOff();
			}
			
			val => gains[vIdx].gain;
		}	
	}
	
	
	//modify global gain (with multiplier)
	fun void setGain(float val){
		//make sure vIdx falls in the appropriate range
		checkRange(val,0.0,1.0) => val;
		softCheck(globalGain,val,sThresh) => int ok;
		if (ok == 1){
			val => globalGain;
			for (int i; i < numSamples; i++){
				gains[i].gain()*globalGain => gains[i].gain;
			}
		}	
	}
	
	
	//turn all envelopes off if all off button is pressed
	fun void allOff(){
		for (int i; i < totalChans; i++){
			envs[i].keyOff();
		}
	}
	
	
	//increment/decrement pan position of sound
	fun void pan(int vIdx,int dir){
		vIdx*numChans => int offset;
		currentEnvs[vIdx] => int theEnv;
		envs[currentEnvs[vIdx]].keyOff();
		if (dir == 1){
			theEnv++;
			(theEnv % numChans) + offset => currentEnvs[vIdx];			
		}else{
			theEnv-1 => theEnv;
			Std.abs((theEnv % numChans)) + offset => currentEnvs[vIdx];			
		}
		envs[currentEnvs[vIdx]].keyOn();
	} 
	
	
	//pseudo soft takeover implementation
	fun int softCheck(float curVal, float targetVal, float threshDiff){
		if (Std.fabs(targetVal - curVal) < threshDiff){
			return 1;
		}else{
			return 0;
		}
	}
	
	
	//make sure value intended to fall between 0 - 1 falls within this range  (0.95 max 
	//since we're using this mostly with gain values)
	fun float checkRange(float val,float min, float max){
		if (val > max){
			max => val;
		}else if(val < min){
			min => val;
		}
		return val;
	}
	
	
	
}